#ifndef	Buffer_H
#define	Buffer_H

class Buffer {
public:
  Buffer(int day, int month, int pktnum, int pktcnt, unsigned int psum,
	 unsigned char *buffer, int len, int dayOfList);
  Buffer(std::istream &is);
  virtual ~Buffer();
  const int getDay(void) const;
  const int getDayOfList(void) const;
  const int getMonth(void) const;
  const int getPktnum(void) const;
  const int getPktcnt(void) const;
  const unsigned int getPsum(void) const;
  const unsigned char *getBuffer(void) const;
  const bool matches (const int dayOfList, const int pktnum) const;
  bool matches (int day, int month, int pktnum);
  bool matches (int day, int month, int pktnum, unsigned int psum);
  void validate(void);
  void inValidate(void);
  const bool isValid(void) const;
  const bool isSuperValid(void) const;
  std::string &dumpBuffer(int tiefe=0) const;

protected:
  // Interface

  // Member

private:
  // Methoden

  // Member
  unsigned char *_buffer;
  int _day;
  int _dayOfList;
  int _month;
  unsigned int _psum;
  int _len;
  int _pktnum;
  int _pktcnt;
  bool _valid;
  bool _supervalid;
};

std::ostream &operator << (std::ostream &os, const Buffer &c);

#endif
