#ifndef	__CTRACE_H__
#define	__CTRACE_H__

// #include <ctrace.H>

#ifndef _AFT

#define __CTRACE__

#include <iostream>

#define DEBUG_ERRORS 1
#define DEBUG_DEBUG  2
#define DEBUG_JOB    4
#define DEBUG_AFUNC  8

// #define DEBUG_ME     DEBUG_ERRORS + DEBUG_DEBUG + DEBUG_JOB + DEBUG_AFUNC
#define DEBUG_ME     DEBUG_ERRORS + DEBUG_JOB + DEBUG_AFUNC

namespace ctrace {

  class Trace {
  public:
    inline Trace(const int x) { _sev=x; };
    inline ~Trace() {};
    inline const int getSev(void) const { return _sev; };
  private:
    int _sev;
  };
  
  static const Trace *dummy = new Trace(0);
  inline const Trace &endl(Trace &t) { return *dummy; };
  
  class TraceException {
  public:
    inline TraceException(const char *problem, const int line, const char *source, const char *function)
    {
      std::cerr << "Exception in " << source << ", Funktion " << function << ", Zeile " << line << "." << std::endl;
      std::cerr << problem << std::endl;
    }
    inline ~TraceException() {} ;
  };
};

inline ctrace::Trace &operator<<(ctrace::Trace &t, std::string &s)
{
#if (DEBUG_ME)
  if (t.getSev() & DEBUG_ME)
    std::cerr << s;
#endif
  return t;
};

inline ctrace::Trace &operator<<(ctrace::Trace &t, int s)
{
#if (DEBUG_ME)
  if (t.getSev() & DEBUG_ME)
    std::cerr << s;
#endif
  return t;
};

inline ctrace::Trace &operator<<(ctrace::Trace &t, const char *s)
{
#if (DEBUG_ME)
  if (t.getSev() & DEBUG_ME)
    std::cerr << s;
#endif
  return t;
};

inline ctrace::Trace &operator<<(ctrace::Trace &t, const ctrace::Trace &(*__pf)(ctrace::Trace&))
{
#if (DEBUG_ME)
  if (t.getSev() & DEBUG_ME)
    std::cerr << std::endl;
#endif
  return t;
};

static ctrace::Trace errexTrace(DEBUG_ERRORS);
static ctrace::Trace debugTrace(DEBUG_DEBUG);
static ctrace::Trace jobTrace(DEBUG_JOB);

#define _AFT ctrace::Trace(DEBUG_AFUNC)

#endif

#endif
