#include <iostream>
#include <fstream>
#include <list>

#include <stdlib.h>
#include <signal.h>

#include "ctrace.H"
#include "IPReceiver.H"
#include "BufferPool.H"
#include "misc.H"

BufferPool bp;

int currentDay(0);
int currentMonth(0);
int currentPkt(0);
int currentPktmax(0);

int anzahlBuffers(0);
int anzahlValidatedBuffers(0);
int anzahlSuperValidatedBuffers(0);

int do_debug(0);

void signalHandler(int)
{
  std::cerr << "SIGTERM erhalten, schreibe Pakete heraus..." << std::endl;
  std::ofstream ofs ("received.data");
  ofs << misc::dumpInt(anzahlBuffers, 0);
  ofs << misc::dumpInt(anzahlValidatedBuffers, 0);
  ofs << misc::dumpInt(anzahlSuperValidatedBuffers, 0);
  ofs < bp;
  ofs.close();
  _exit(1);
}

int main (int argc, char *argv[])
{
  _AFT;

#ifndef __CTRACE__
  __ctraceStatus->setStatus('D', false);
  __ctraceStatus->setStatus('E', true);
  __ctraceStatus->setStatus('J', true);
  __ctraceStatus->setStatus('A', false);
#endif

  int adapter(0), demux(0);
  char opt;
	
  while ((opt = getopt(argc, argv, "a:d:D")) != -1) {
    switch (opt) {
    case 'a':
      adapter = atoi(optarg);
      break;
    case 'd':
      demux = atoi(optarg);
      break;
    case 'D':
      do_debug = 1;
      break;
    }
  }

#if 1
  std::ifstream ifs ("received.data");
  if (ifs.good()) {
    anzahlBuffers = misc::loadInt(ifs);
    anzahlValidatedBuffers = misc::loadInt(ifs);
    anzahlSuperValidatedBuffers = misc::loadInt(ifs);
    ifs > bp;
    ifs.close();
  }

  IPReceiver r(adapter, demux);                      // starte Receiver-Thread

  struct sigaction sa;
  sa.sa_handler = signalHandler;
  __sigemptyset(&sa.sa_mask);
  sa.sa_flags = SA_ONESHOT;

  int rv = sigaction(SIGTERM, &sa, NULL);
  if (rv != 0) {
    errexTrace << "Signalhandler fr TERM nicht installiert." << ctrace::endl;
  }
  rv = sigaction(SIGQUIT, &sa, NULL);
  if (rv != 0) {
    errexTrace << "Signalhandler fr QUIT nicht installiert." << ctrace::endl;
  }
  rv = sigaction(SIGINT, &sa, NULL);
  if (rv != 0) {
    errexTrace << "Signalhandler fr INT nicht installiert." << ctrace::endl;
  }
  while (1) {
    sleep(5);
    int sum(0);
    for (int i(0); i < 8; i++) {
      sum += bp.getPktMax(i);
    }
    std::cerr << "Buffers: " << anzahlSuperValidatedBuffers << "/"
	      << anzahlValidatedBuffers << "/" << anzahlBuffers << "/"
	      << sum << std::endl;
    std::cerr << "loading: " << currentDay << "." << currentMonth << ". (";
    std::cerr << currentPkt << "/" << currentPktmax << ")" << std::endl;

    std::string r("");
    std::cerr << bp.printStats(r).c_str();
    if (anzahlBuffers == anzahlValidatedBuffers) {
      break;
    }
  }

  if (anzahlBuffers != 0) {
    std::cout << bp;
  }

#else

  std::ifstream ifs("./received_data/infosat_13_10");
  std::string s;
  char l[4092];
  while (ifs.good() && !ifs.eof()) {
    ifs.getline(l, 4092);
    char *p = ::strrchr(l, '\r');
    if (p) *p='\n';
    while ((p = strchr(l, 0x8a)) != NULL) *p='\t';
    p = l + ::strlen(l);
    p--;			// CR
    p--;			// "\"
    if (*p == '\\') {
      *p = '\0';
    }
    s += l;
  }

  EPG epg(s);

#endif

  return 0;
}
