#include <iostream>

#include "ctrace.H"
#include "InvalidDataException.H"
#include "misc.H"

const char *misc::itoa(const int w)
{
#ifdef PROFILING
  _AFT;
#endif

  static char buf[32];
  int wert = w;
  bool vz(false);
  register int i(30);
  if (wert < 0) {
    vz = true;
    wert = -wert;
  }
  buf[31]='\0';
  while (i > 1) {
    buf[i] = '0' + (wert % 10);
    wert = wert / 10;
    if (wert == 0) break;
    i--;
  }
  if (vz) buf[--i]='-';
  return &(buf[i]);
}

const char *misc::itox(const int w, const int l)
{
#ifdef PROFILING
  _AFT;
#endif

  static char buf[32];
  int wert = w;
  bool vz(false);
  register int i(30);
  if (wert < 0) {
    vz = true;
    wert = -wert;
  }
  buf[31]='\0';
  while (i > 1) {
    buf[i] = '0' + (wert % 16);
    if (buf[i] > '9') buf[i] += 7;
    wert = wert / 16;
    if (wert == 0) break;
    i--;
  }
  while (i > (31 - l)) {
    buf[i] = '0';
    i--;
  }
  if (vz) buf[--i]='-';
  return &(buf[i]);
}

const char *misc::itoa(const unsigned int w)
{
#ifdef PROFILING
  _AFT;
#endif

  static char buf[32];
  unsigned int wert = w;
  register int i(30);
  buf[31]='\0';
  while (i > 1) {
    buf[i] = '0' + (wert % 10);
    wert = wert / 10;
    if (wert == 0) break;
    i--;
  }
  return &(buf[i]);
}

const char *misc::itox(const unsigned int w, const int l)
{
#ifdef PROFILING
  _AFT;
#endif

  static char buf[32];
  unsigned int wert = w;
  register int i(30);
  buf[31]='\0';
  while (i > 1) {
    buf[i] = '0' + (wert % 16);
    if (buf[i] > '9') buf[i] += 7;
    wert = wert / 16;
    if (wert == 0) break;
    i--;
  }
  while (i > (31 - l)) {
    buf[i] = '0';
    i--;
  }
  return &(buf[i]);
}

const char *misc::ctox(unsigned char c)
{
  static char buf[3];
  buf[2] = '\0';
  buf[1] = '0' + (c & 0x0f);
  if (buf[1] > '9') buf[1] += 7;
  c = c / 16;
  buf[0] = '0' + (c & 0x0f);
  if (buf[0] > '9') buf[0] += 7;
  return buf;
}

std::string misc::spaces(int anzahl)
{
  static std::string rv;
  rv="";
  while ((anzahl--) > 0) {
    rv += " ";
  }
  return rv;
}

int misc::loadInt(std::istream &is)
{
  std::string zeile;
  int rv(0);
  int vz=1;
  is >> zeile;
  if (zeile.substr(0,5) == "<int>") {
    zeile = zeile.substr(5);
    while (zeile[0] != '<') {
      if (zeile[0] == '-') {
	vz=-vz;
      }
      rv *= 10;
      rv += (zeile[0] - '0');
      zeile = zeile.substr(1);
    }
    if (zeile != "</int>") {
      std::string err("Token </int> nicht gefunden");
      errexTrace << "kein valides Datenfile:" << ctrace::endl;
      errexTrace << err << ctrace::endl;
      throw new InvalidDataException(err.c_str(),
				     __LINE__, __FILE__, __PRETTY_FUNCTION__);
    }
  } else {
    std::string err("Token <int> nicht gefunden");
    errexTrace << "kein valides Datenfile:" << ctrace::endl;
    errexTrace << err << ctrace::endl;
    throw new InvalidDataException(err.c_str(),
				   __LINE__, __FILE__, __PRETTY_FUNCTION__);
  }
  return rv * vz;
}

std::string misc::dumpInt(int wert, int tiefe)
{
  static std::string rv;
  rv = spaces(tiefe);
  rv += "<int>";
  rv += itoa(wert);
  rv += "</int>\n";
  return rv;
}

unsigned int misc::loadUInt(std::istream &is)
{
  std::string zeile;
  std::string zeile2;
  unsigned int rv(0);
  is >> zeile;
  is >> zeile2;
  zeile = zeile + " " + zeile2;
  if (zeile.substr(0,14) == "<unsigned int>") {
    zeile = zeile.substr(14);
    while (zeile[0] != '<') {
      rv *= 10;
      rv += (zeile[0] - '0');
      zeile = zeile.substr(1);
    }
    is >> zeile2;
    zeile = zeile + " " + zeile2;
    if (zeile != "</unsigned int>") {
      std::string err("Token </unsigned int> nicht gefunden, sondern ");
      err += zeile;
      errexTrace << "kein valides Datenfile:" << ctrace::endl;
      errexTrace << err << ctrace::endl;
      throw new InvalidDataException(err.c_str(),
				     __LINE__, __FILE__, __PRETTY_FUNCTION__);
    }
  } else {
    std::string err("Token <unsigned int> nicht gefunden, sondern ");
      err += zeile;
    errexTrace << "kein valides Datenfile:" << ctrace::endl;
    errexTrace << err << ctrace::endl;
    throw new InvalidDataException(err.c_str(),
				   __LINE__, __FILE__, __PRETTY_FUNCTION__);
  }
  return rv;
}

std::string misc::dumpUInt(unsigned int wert, int tiefe)
{
  static std::string rv;
  rv = spaces(tiefe);
  rv += "<unsigned int>";
  rv += itoa(wert);
  rv += "</unsigned int>\n";
  return rv;
}

bool misc::loadBool(std::istream &is)
{
  std::string zeile;
  bool rv(false);
  is >> zeile;
  if (zeile.substr(0,6) == "<bool>") {
    zeile = zeile.substr(6);
    if (zeile.substr(0,4) == "TRUE") {
      rv=true;
      zeile = zeile.substr(4);
    } else {
      rv=false;
      zeile = zeile.substr(5);
    }
    if (zeile != "</bool>") {
      std::string err("Token </bool> nicht gefunden, sondern ");
      err += zeile;
      errexTrace << "kein valides Datenfile:" << ctrace::endl;
      errexTrace << err << ctrace::endl;
      throw new InvalidDataException(err.c_str(),
				     __LINE__, __FILE__, __PRETTY_FUNCTION__);
    }
  } else {
    std::string err("Token <bool> nicht gefunden, sondern ");
    err += zeile;
    errexTrace << "kein valides Datenfile:" << ctrace::endl;
    errexTrace << err << ctrace::endl;
    throw new InvalidDataException(err.c_str(),
				   __LINE__, __FILE__, __PRETTY_FUNCTION__);
  }
  return rv;
}

std::string misc::dumpBool(bool wert, int tiefe)
{
  static std::string rv;
  rv = spaces(tiefe);
  rv += "<bool>";
  if (wert) {
    rv += "TRUE";
  } else {
    rv += "FALSE";
  }
  rv += "</bool>\n";
  return rv;
}

unsigned char *misc::loadUCharP(std::istream &is)
{
  std::string zeile;
  std::string zeile2;
  std::string rv;
  unsigned char *rp;
  is >> zeile;
  is >> zeile2;
  zeile = zeile + " " + zeile2;
  is >> zeile2;
  zeile = zeile + " " + zeile2;
  if (zeile == "<unsigned char *>") {
    unsigned int len = loadUInt(is);
    is >> zeile;
    if (zeile == "<data>") {
      while (len > 0)  {
	is >> zeile;		// Jetzt kommen len Bytes Daten als ASCII-Dump
	while (zeile.length() > 0) {
	  unsigned char c;
	  if (zeile[0] < ':') {
	    c = (zeile[0] - '0') * 16;
	  } else {
	    c = (zeile[0] - '7') * 16;
	  }
	  if (zeile[1] < ':') {
	    c = c + (zeile[1] - '0');
	  } else {
	    c = c + (zeile[1] - '7');
	  }
	  rv = rv + (char)c;
	  len --;
	  zeile = zeile.substr(2);
	}
      }
      rp = (unsigned char *)::strdup(rv.c_str());
      is >> zeile;
      if (zeile != "</data>") {
	std::string err("Token </data> nicht gefunden, sondern ");
	err += zeile;
	errexTrace << "kein valides Datenfile:" << ctrace::endl;
	errexTrace << err << ctrace::endl;
	throw new InvalidDataException(err.c_str(),
				       __LINE__, __FILE__, __PRETTY_FUNCTION__);
      }
      is >> zeile;
      is >> zeile2;
      zeile += " " + zeile2;
      is >> zeile2;
      zeile += " " + zeile2;
      if (zeile != "</unsigned char *>") {
	std::string err("Token </unsigned char *> nicht gefunden, sondern ");
	err += zeile;
	errexTrace << "kein valides Datenfile:" << ctrace::endl;
	errexTrace << err << ctrace::endl;
	throw new InvalidDataException(err.c_str(),
				       __LINE__, __FILE__, __PRETTY_FUNCTION__);
      }
    } else {
      std::string err("Token <data> nicht gefunden, sondern ");
      err += zeile;
      errexTrace << "kein valides Datenfile:" << ctrace::endl;
      errexTrace << err << ctrace::endl;
      throw new InvalidDataException(err.c_str(),
				     __LINE__, __FILE__, __PRETTY_FUNCTION__);
    }
  } else {
    std::string err("Token <unsigned char *> nicht gefunden, sondern ");
    err += zeile;
    errexTrace << "kein valides Datenfile:" << ctrace::endl;
    errexTrace << err << ctrace::endl;
    throw new InvalidDataException(err.c_str(),
				   __LINE__, __FILE__, __PRETTY_FUNCTION__);
  }
  return rp;
}

std::string misc::dumpUCharP(unsigned char *buffer, int tiefe)
{
  static std::string rv;
  rv = spaces(tiefe);
  rv += "<unsigned char *>\n";
  rv += dumpUInt((const unsigned int)::strlen((const char *)buffer), tiefe+1);
  rv += spaces(tiefe + 1);
  rv += "<data>\n";
  rv += spaces(tiefe + 2);
  rv += ctox(buffer[0]);
  int i(1);
  while (buffer[i] != '\0') {
    if ((i % 32) == 0) {
      rv += "\n";
      rv += spaces(tiefe + 2);
    }
    rv += ctox(buffer[i]);
    i++;
  }
  rv += "\n";
  rv += spaces(tiefe + 1);
  rv += "</data>\n";
  rv += spaces(tiefe);
  rv += "</unsigned char *>\n";
  return rv;
}

void misc::strip(std::string &s) {
  while (s[0] == ' ') {
    s.replace(0,1,"");
  }
}
